"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handle = void 0;
function handle(context, config) {
    return __awaiter(this, void 0, void 0, function () {
        var issueNumber, owner, repo, logger, currentAction, type, currentLabels_1, _a, _b, _i, action, labelsToAdd, labelsToRemove, currentLabels_2, _c, _d, _e, action, labelsToAdd, labelsToRemove;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    issueNumber = context.issue().number;
                    owner = context.issue().owner;
                    repo = context.issue().repo;
                    logger = context.log.child({
                        owner: owner,
                        repo: repo,
                        issue: issueNumber,
                        app: "probot-labler",
                    });
                    if (!!context.isBot) return [3 /*break*/, 12];
                    currentAction = context.payload.action;
                    type = context.payload.issue ? "issue" : "pull_request";
                    if (!(type === "issue" && config.issues)) return [3 /*break*/, 6];
                    currentLabels_1 = context.payload.issue.labels.map(function (x) {
                        return x.name;
                    });
                    _a = [];
                    for (_b in config.issues)
                        _a.push(_b);
                    _i = 0;
                    _f.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 6];
                    action = _a[_i];
                    if (!(action === currentAction)) return [3 /*break*/, 5];
                    if (!config.issues[action].add) return [3 /*break*/, 3];
                    labelsToAdd = config.issues[action].add.filter(function (x) {
                        return !currentLabels_1.includes(x);
                    });
                    return [4 /*yield*/, addLabels(context, labelsToAdd)];
                case 2:
                    _f.sent();
                    logger.debug("added labels: " + labelsToAdd);
                    _f.label = 3;
                case 3:
                    if (!config.issues[action].remove) return [3 /*break*/, 5];
                    labelsToRemove = config.issues[action].remove.filter(function (x) {
                        return currentLabels_1.includes(x);
                    });
                    return [4 /*yield*/, removeLabels(context, labelsToRemove)];
                case 4:
                    _f.sent();
                    logger.debug("removed labels: " + labelsToRemove);
                    _f.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 1];
                case 6:
                    if (!(type === "pull_request" && config.pulls)) return [3 /*break*/, 12];
                    currentLabels_2 = context.payload.pull_request.labels.map(function (x) {
                        return x.name;
                    });
                    _c = [];
                    for (_d in config.pulls)
                        _c.push(_d);
                    _e = 0;
                    _f.label = 7;
                case 7:
                    if (!(_e < _c.length)) return [3 /*break*/, 12];
                    action = _c[_e];
                    if (!(action === currentAction)) return [3 /*break*/, 11];
                    if (!config.pulls[action].add) return [3 /*break*/, 9];
                    labelsToAdd = config.pulls[action].add.filter(function (x) {
                        return !currentLabels_2.includes(x);
                    });
                    return [4 /*yield*/, addLabels(context, labelsToAdd)];
                case 8:
                    _f.sent();
                    logger.debug("added labels: " + labelsToAdd);
                    _f.label = 9;
                case 9:
                    if (!config.pulls[action].remove) return [3 /*break*/, 11];
                    labelsToRemove = config.pulls[action].remove.filter(function (x) {
                        return currentLabels_2.includes(x);
                    });
                    return [4 /*yield*/, removeLabels(context, labelsToRemove)];
                case 10:
                    _f.sent();
                    logger.debug("removed labels: " + labelsToRemove);
                    _f.label = 11;
                case 11:
                    _e++;
                    return [3 /*break*/, 7];
                case 12: return [2 /*return*/];
            }
        });
    });
}
exports.handle = handle;
function addLabels(context, labels) {
    return __awaiter(this, void 0, void 0, function () {
        var issue;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    issue = context.issue({ labels: labels });
                    return [4 /*yield*/, context.github.issues
                            .addLabels({
                            repo: issue.repo,
                            owner: issue.owner,
                            issue_number: issue.number,
                            labels: issue.labels,
                        })
                            .catch(function (err) {
                            throw new Error("Couldn't add labels to issue: " + context.issue().number + ", " + err);
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function removeLabels(context, labels) {
    return __awaiter(this, void 0, void 0, function () {
        var _i, labels_1, label, issue;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _i = 0, labels_1 = labels;
                    _a.label = 1;
                case 1:
                    if (!(_i < labels_1.length)) return [3 /*break*/, 4];
                    label = labels_1[_i];
                    issue = context.issue({ name: label });
                    return [4 /*yield*/, context.github.issues
                            .removeLabel({
                            repo: issue.repo,
                            owner: issue.owner,
                            issue_number: issue.number,
                            name: issue.name,
                        })
                            .catch(function (err) {
                            throw new Error("Couldn't add labels to issue: " + context.issue().number + ", " + err);
                        })];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=handler.js.map