"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.schema = void 0;
var Joi = require("joi");
var pullsActions = [
    "assigned",
    "unassigned",
    "labeled",
    "unlabeled",
    "opened",
    "edited",
    "closed",
    "reopened",
    "synchronize",
    "ready_for_review",
    "locked",
    "unlocked",
];
var issuesActions = [
    "opened",
    "edited",
    "deleted",
    "transferred",
    "pinned",
    "unpinned",
    "closed",
    "reopened",
    "assigned",
    "unassigned",
    "labeled",
    "unlabeled",
    "locked",
    "unlocked",
    "milestoned",
    "demilestoned",
];
var fields = {
    add: Joi.array().description("Labels to add for this action"),
    remove: Joi.array().description("Labels to remove for this action"),
};
function buildActionObject(actions) {
    var actionsMap = {};
    actions.forEach(function (action) {
        actionsMap[action] = Joi.object().keys(fields);
    });
    return Joi.object().keys(actionsMap);
}
//
// issues:
//   opened:
//     add:
//       - triage/needs-triage
//   locked:
//     add:
//       - locked
exports.schema = Joi.object().keys({
    issues: buildActionObject(issuesActions),
    pulls: buildActionObject(pullsActions),
});
//# sourceMappingURL=models.js.map